Package com.documentum.fc.client.search

# Interface IDfSearchMetadataManager

All Superinterfaces:
  `IDfSearchSourceContainer`

public interface IDfSearchMetadataManager extends IDfSearchSourceContainer
Provides a facade to search metadata. Encapsulates metadata server selection.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `convertDocbaseToMimeFormat(String docbaseFormat)`
  Converts a repository format value to MIME format value.
  `String`
  `convertMimeToDocbaseFormat(String mimeFormat)`
  Converts a MIME format value to repository format value.
  `IDfEnumeration`
  `getAvailableTypes()`
  Provides an enumeration of available searchable types.
  `IDfEnumeration`
  `getAvailableTypes(boolean includeObsoleteTypes)`
  Provides an enumeration of available searchable types derived from a specified base type.
  `IDfEnumeration`
  `getAvailableTypes(String baseType)`
  Provides an enumeration available types derived from a specified base type.
  `IDfEnumeration`
  `getAvailableTypes(String baseType, boolean includeObsoleteTypes)`
  Provides an enumeration available types derived from a specified base type.
  `String`
  `getDefaultTypeName()`
  Provides access to the default type selection.
  `IDfList`
  `getDOSExtensions(String mimeFormat)`
  Gets the DOS extensions associated to the specified MIME format value in the repository.
  `String`
  `getMetadataDocbase()`
  Gets the repository to pick the metadata information from information on types.
  `IDfSessionManager`
  `getSessionMgr()`
  Provides access to an internal instance of the Session Manager.
  `IDfSearchSourceMap`
  `getSourceMap()`
  Provides convenient access to an internal reference of the source map.
  `IDfSearchTypeAssistant`
  `getTypeAssistant(String typeName)`
  Provides access to a type assistant for the given type.
  `IDfSearchTypeAssistant`
  `getTypeAssistant(String typeName, boolean includeObsoleteTypes)`
  Provides access to a type assistant for the given type.
  `boolean`
  `isFulltextCompliant()`
  Informs if manager is in a full-text compliant mode.
  `void`
  `setFulltextCompliant(boolean fulltextCompliant)`
  Switches the compliance mode for supporting only full-text compliant constructs.

  ### Methods inherited from interface com.documentum.fc.client.search.IDfSearchSourceContainer

  `addSelectedSource, clearSelectedSources, getSelectedSourceCount, getSelectedSources, removeSelectedSource`

- ## Method Details

  - ### getSessionMgr

    IDfSessionManager getSessionMgr()
    Provides access to an internal instance of the Session Manager. This method is reserved for internal use.
    Returns:
      A session manager instance.

  - ### getSourceMap

    IDfSearchSourceMap getSourceMap()
    Provides convenient access to an internal reference of the source map. This method is reserved for internal use.
    Returns:
      The source map reference.

  - ### isFulltextCompliant

    boolean isFulltextCompliant()
    Informs if manager is in a full-text compliant mode. If compliance is requested, some of the metadata options that can break the compliance are excluded from the returned containers.
    Returns:
      `true`, if full-text compliance is requested; `false` otherwise.

  - ### setFulltextCompliant

    void setFulltextCompliant(boolean fulltextCompliant)
    Switches the compliance mode for supporting only full-text compliant constructs.
    Parameters:
      `fulltextCompliant` - `true` if full-text compliance is requested; `false` otherwise.

  - ### getMetadataDocbase

    String getMetadataDocbase() throws DfException
    Gets the repository to pick the metadata information from information on types.
    Returns:
      The metadata server repository.
    Throws:
      `DfException` - If the default metadata server repository is searched for but not available (the default metadata server repository is required when only external sources have been selected through the search service).

  - ### getAvailableTypes

    IDfEnumeration getAvailableTypes() throws DfException
    Provides an enumeration of available searchable types.
    Returns:
      An enumeration of available types (IDfEnumeration of IDfSearchTypeAssistant).
    Throws:
      `DfException` - If an error occurs while getting the types information.

  - ### getAvailableTypes

    IDfEnumeration getAvailableTypes(boolean includeObsoleteTypes) throws DfException
    Provides an enumeration of available searchable types derived from a specified base type. The assistant for the base type itself is returned as the first element of the enumeration.
    Parameters:
      `includeObsoleteTypes` - Determines whether obsolete types should be returned or not.
    Returns:
      An enumeration of available types (IDfEnumeration of IDfSearchTypeAssistant).
    Throws:
      `DfException` - If an error occurs while getting the types information.

  - ### getAvailableTypes

    IDfEnumeration getAvailableTypes(String baseType) throws DfException
    Provides an enumeration available types derived from a specified base type. The assistant for the base type itself is returned as the first element of the enumeration.
    Parameters:
      `baseType` - The base type.
    Returns:
      An enumeration available types (IDfEnumeration of IDfSearchTypeAssistant).
    Throws:
      `DfException` - If an error occurs while getting the types information.

  - ### getAvailableTypes

    IDfEnumeration getAvailableTypes(String baseType, boolean includeObsoleteTypes) throws DfException
    Provides an enumeration available types derived from a specified base type. The assistant for the base type itself is returned as the first element of the enumeration.
    Parameters:
      `baseType` - The base type.
      `includeObsoleteTypes` - Determins whether obsolete types should be returned or not.
    Returns:
      An enumeration available types (IDfEnumeration of IDfSearchTypeAssistant).
    Throws:
      `DfException` - If an error occurs while getting the types information.

  - ### getTypeAssistant

    IDfSearchTypeAssistant getTypeAssistant(String typeName) throws DfException
    Provides access to a type assistant for the given type.
    Contrary to methods getAvailableTypes, this type may not have the flag 'is_searchable' set to true.
    Parameters:
      `typeName` - The type name, such as `dm_document`.``
    Returns:
      The corresponding type assistant instance; or `null` if the type is not found.
    Throws:
      `DfException` - If an error occurs while getting the type information.

  - ### getTypeAssistant

    IDfSearchTypeAssistant getTypeAssistant(String typeName, boolean includeObsoleteTypes) throws DfException
    Provides access to a type assistant for the given type.
    Parameters:
      `typeName` - The type name, such as `dm_document`.``
      `includeObsoleteTypes` - Determines whether obsolete types should be returned or not by the type assistant.
    Returns:
      The corresponding type assistant instance; or `null` if the type is not found.
    Throws:
      `DfException` - If an error occurs while getting the type information.

  - ### getDefaultTypeName

    String getDefaultTypeName()
    Provides access to the default type selection. Always returns "dm_document".
    Returns:
      The name of the default type.

  - ### convertMimeToDocbaseFormat

    String convertMimeToDocbaseFormat(String mimeFormat) throws DfException
    Converts a MIME format value to repository format value.
    Parameters:
      `mimeFormat` - The MIME format value.
    Returns:
      The converted repository format value.
    Throws:
      `DfException` - If an error occurs while converting the value.

  - ### convertDocbaseToMimeFormat

    String convertDocbaseToMimeFormat(String docbaseFormat) throws DfException
    Converts a repository format value to MIME format value.
    Parameters:
      `docbaseFormat` - The repository format value.
    Returns:
      The converted MIME format value.
    Throws:
      `DfException` - If an error occurs while converting the value.

  - ### getDOSExtensions

    IDfList getDOSExtensions(String mimeFormat) throws DfException
    Gets the DOS extensions associated to the specified MIME format value in the repository.
    Parameters:
      `mimeFormat` - The MIME format value.
    Returns:
      The list of DOS extensions associated to the MIME type as String objetcs.
    Throws:
      `DfException` - If an error occurs while converting the value.